'
'  InstallServo     set up a timer output channel to control a servo
'
'  Invocation:    gosub  InstallServo, toc
'          or:    n = usr(InstallServo, toc)
'
'  When called as a function (USR format), InstallServo returns a 0
'  if the setup worked, or -1 if the toc argument was invalid.
'
'  Upon exit, the specified TOC is set to 0, effectively stopping the
'  motor.
'

InstallServo:

select  pick(0)
    case  TOC2                  ' if this is TOC2...
    push  $c0                   ' push the proper TCTL1 value
    push  $40                   ' push the proper OC1D/OC1M value
    endcase

    case  TOC3
    push  $30
    push  $20
    endcase

    case  TOC4
    push  $0c
    push  $10
    endcase

    case  TOC5
    push  $03
    push  $08
    endcase

    drop  1                         ' drop invalid TOC argument!
    return  -1                      ' report a failure
endselect

pokeb  oc1d, peekb(oc1d) and (pick(0) xor $ff)      ' clear bit on TOC1
pokeb  oc1m, peekb(oc1m) or pull()      ' connect to TOC1
pokeb  tctl1, peekb(tctl1) or pull()    ' set bit on TOC
poke  pull(), 0                     ' clear TOC for now
poke  toc1, 0                       ' TOC1 hits at 0
return  0                           ' show all went well


